/*
 * Copyright 2004-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.framework.ejb.unit;

import java.util.List;

/**
 * @author taedium
 * 
 */
public interface PersistentStateDesc {

    String getName();

    PersistentClassDesc getPersistentClassDesc();

    boolean hasColumn(String columnName);

    PersistentColumn getColumn();

    void setColumn(PersistentColumn column);

    Class<?> getPersistentStateClass();

    Class<?> getPersistenceTargetClass();

    Object getValue(Object target, ProxiedObjectResolver resolver);

    PersistentClassDesc getEmbeddedClassDesc();

    List<PersistentStateDesc> getEmbeddedStateDescs();

    void adjustPrimaryKeyColumns(List<PersistentJoinColumn> pkJoinColumns);

    void setupForeignKeyColumns(PersistentClassDesc relationship);

    List<PersistentJoinColumn> getForeignKeyColumns();

    List<PersistentJoinColumn> getJoinColumns();

    void setJoinColumns(List<PersistentJoinColumn> joinColumns);

    PersistentStateAccessor getAccessor();

    PersistentStateType getPersistentStateType();

    boolean isIdentifier();

}
